=== debian/changelog ===
bpftrace (0.11.3-5+deb11u1) bullseye; urgency=medium

  * d/patches: add patch to fix array indexing (Closes: #1001449).

 -- Vincent Bernat <bernat@debian.org>  Fri, 10 Dec 2021 19:16:15 +0100

bpftrace (0.11.3-5) unstable; urgency=medium

  * d/control: do not build-depends on libbfd-dev (Closes: #980438)

 -- Vincent Bernat <bernat@debian.org>  Tue, 19 Jan 2021 11:07:36 +0100

bpftrace (0.11.3-4) unstable; urgency=medium

  * d/control: build-depends on libbpf-dev for BTF support (Closes: #980299)

 -- Vincent Bernat <bernat@debian.org>  Sun, 17 Jan 2021 16:55:08 +0100

bpftrace (0.11.3-3) unstable; urgency=medium

  * d/control: build-depends on libbfd-dev (Closes: #975867)

 -- Vincent Bernat <bernat@debian.org>  Thu, 26 Nov 2020 19:42:09 +0100

bpftrace (0.11.3-2) unstable; urgency=medium

  * d/control: build-depends on LLVM 11 toolchain (Closes: #974799)

 -- Vincent Bernat <bernat@debian.org>  Sun, 15 Nov 2020 07:22:03 +0100

bpftrace (0.11.3-1) unstable; urgency=medium

  * New upstream release.

 -- Vincent Bernat <bernat@debian.org>  Fri, 13 Nov 2020 19:07:38 +0100
